/* CommonUtils.c generated by valac 0.10.0, the Vala compiler
 * generated from CommonUtils.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*- */
/*
    This file is part of Déjà Dup.
    © 2008,2009 Michael Terry <mike@mterry.name>

    Déjà Dup is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Déjà Dup is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Déjà Dup.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DEJA_DUP_TYPE_BACKEND (deja_dup_backend_get_type ())
#define DEJA_DUP_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DEJA_DUP_TYPE_BACKEND, DejaDupBackend))
#define DEJA_DUP_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DEJA_DUP_TYPE_BACKEND, DejaDupBackendClass))
#define DEJA_DUP_IS_BACKEND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DEJA_DUP_TYPE_BACKEND))
#define DEJA_DUP_IS_BACKEND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DEJA_DUP_TYPE_BACKEND))
#define DEJA_DUP_BACKEND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DEJA_DUP_TYPE_BACKEND, DejaDupBackendClass))

typedef struct _DejaDupBackend DejaDupBackend;
typedef struct _DejaDupBackendClass DejaDupBackendClass;

typedef enum  {
	DEJA_DUP_BACKUP_ERROR_BAD_CONFIG,
	DEJA_DUP_BACKUP_ERROR_ALREADY_RUNNING
} DejaDupBackupError;
#define DEJA_DUP_BACKUP_ERROR deja_dup_backup_error_quark ()


#define DEJA_DUP_INCLUDE_LIST_KEY "include-list"
#define DEJA_DUP_EXCLUDE_LIST_KEY "exclude-list"
#define DEJA_DUP_BACKEND_KEY "backend"
#define DEJA_DUP_ROOT_PROMPT_KEY "root-prompt"
#define DEJA_DUP_ENCRYPT_KEY "encrypt"
#define DEJA_DUP_LAST_RUN_KEY "last-run"
#define DEJA_DUP_PERIODIC_KEY "periodic"
#define DEJA_DUP_PERIODIC_PERIOD_KEY "periodic-period"
#define DEJA_DUP_DELETE_AFTER_KEY "delete-after"
GQuark deja_dup_backup_error_quark (void);
void deja_dup_update_last_run_timestamp (GError** error);
GSettings* deja_dup_get_settings (const char* subdir);
char* deja_dup_get_trash_path (void);
GFile* deja_dup_parse_dir (const char* dir);
GFile** deja_dup_parse_dir_list (const char** dirs, int dirs_length1, int* result_length1);
#define DEJA_DUP_SSH_USERNAME_KEY "username"
#define DEJA_DUP_SSH_SERVER_KEY "server"
#define DEJA_DUP_SSH_PORT_KEY "port"
#define DEJA_DUP_SSH_DIRECTORY_KEY "directory"
void deja_dup_convert_ssh_to_file (void);
#define DEJA_DUP_FILE_ROOT "File"
#define DEJA_DUP_FILE_PATH_KEY "path"
void deja_dup_initialize (void);
char* deja_dup_get_file_desc (GFile* file);
char* deja_dup_get_location_desc (void);
GType deja_dup_backend_get_type (void) G_GNUC_CONST;
DejaDupBackend* deja_dup_backend_get_default (GError** error);
char* deja_dup_backend_get_location_pretty (DejaDupBackend* self, GError** error);
gint deja_dup_get_full_backup_threshold (void);
void deja_dup_get_full_backup_threshold_date (GDate* result);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static int _vala_strcmp0 (const char * str1, const char * str2);



GQuark deja_dup_backup_error_quark (void) {
	return g_quark_from_static_string ("deja_dup_backup_error-quark");
}


void deja_dup_update_last_run_timestamp (GError** error) {
	GTimeVal cur_time = {0};
	char* cur_time_str;
	GSettings* settings;
	g_get_current_time (&cur_time);
	g_get_current_time (&cur_time);
	cur_time_str = g_time_val_to_iso8601 (&cur_time);
	settings = deja_dup_get_settings (NULL);
	g_settings_set_string (settings, DEJA_DUP_LAST_RUN_KEY, cur_time_str);
	_g_object_unref0 (settings);
	_g_free0 (cur_time_str);
}


char* deja_dup_get_trash_path (void) {
	char* result = NULL;
	result = g_build_filename (g_get_user_data_dir (), "Trash", NULL);
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GFile* deja_dup_parse_dir (const char* dir) {
	GFile* result = NULL;
	char* s;
	g_return_val_if_fail (dir != NULL, NULL);
	s = g_strdup (dir);
	if (_vala_strcmp0 (s, "$HOME") == 0) {
		char* _tmp0_;
		s = (_tmp0_ = g_strdup (g_get_home_dir ()), _g_free0 (s), _tmp0_);
	} else {
		if (_vala_strcmp0 (s, "$DESKTOP") == 0) {
			char* _tmp1_;
			s = (_tmp1_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_DESKTOP)), _g_free0 (s), _tmp1_);
		} else {
			if (_vala_strcmp0 (s, "$DOCUMENTS") == 0) {
				char* _tmp2_;
				s = (_tmp2_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_DOCUMENTS)), _g_free0 (s), _tmp2_);
			} else {
				if (_vala_strcmp0 (s, "$DOWNLOAD") == 0) {
					char* _tmp3_;
					s = (_tmp3_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD)), _g_free0 (s), _tmp3_);
				} else {
					if (_vala_strcmp0 (s, "$MUSIC") == 0) {
						char* _tmp4_;
						s = (_tmp4_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_MUSIC)), _g_free0 (s), _tmp4_);
					} else {
						if (_vala_strcmp0 (s, "$PICTURES") == 0) {
							char* _tmp5_;
							s = (_tmp5_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_PICTURES)), _g_free0 (s), _tmp5_);
						} else {
							if (_vala_strcmp0 (s, "$PUBLIC_SHARE") == 0) {
								char* _tmp6_;
								s = (_tmp6_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_PUBLIC_SHARE)), _g_free0 (s), _tmp6_);
							} else {
								if (_vala_strcmp0 (s, "$TEMPLATES") == 0) {
									char* _tmp7_;
									s = (_tmp7_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_TEMPLATES)), _g_free0 (s), _tmp7_);
								} else {
									if (_vala_strcmp0 (s, "$TRASH") == 0) {
										char* _tmp8_;
										s = (_tmp8_ = deja_dup_get_trash_path (), _g_free0 (s), _tmp8_);
									} else {
										if (_vala_strcmp0 (s, "$VIDEOS") == 0) {
											char* _tmp9_;
											s = (_tmp9_ = g_strdup (g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS)), _g_free0 (s), _tmp9_);
										} else {
											gboolean _tmp10_ = FALSE;
											char* _tmp11_;
											gboolean _tmp12_;
											if ((_tmp12_ = (_tmp11_ = g_uri_parse_scheme (s)) == NULL, _g_free0 (_tmp11_), _tmp12_)) {
												_tmp10_ = !g_path_is_absolute (s);
											} else {
												_tmp10_ = FALSE;
											}
											if (_tmp10_) {
												char* _tmp13_;
												s = (_tmp13_ = g_build_filename (g_get_home_dir (), s, NULL), _g_free0 (s), _tmp13_);
											} else {
												result = _g_object_ref0 (g_file_parse_name (s));
												_g_free0 (s);
												return result;
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	result = g_file_new_for_path (s);
	_g_free0 (s);
	return result;
}


GFile** deja_dup_parse_dir_list (const char** dirs, int dirs_length1, int* result_length1) {
	GFile** result = NULL;
	gint rv_length1;
	gint _rv_size_;
	GFile** _tmp0_;
	GFile** rv;
	gint i;
	GFile** _tmp3_;
	rv = (_tmp0_ = g_new0 (GFile*, dirs_length1 + 1), rv_length1 = dirs_length1, _rv_size_ = rv_length1, _tmp0_);
	i = 0;
	{
		const char** s_collection;
		int s_collection_length1;
		int s_it;
		s_collection = dirs;
		s_collection_length1 = dirs_length1;
		for (s_it = 0; s_it < dirs_length1; s_it = s_it + 1) {
			char* s;
			s = g_strdup ((char*) s_collection[s_it]);
			{
				GFile* *_tmp1_;
				GFile* _tmp2_;
				_tmp1_ = &rv[i++];
				(*_tmp1_) = (_tmp2_ = deja_dup_parse_dir (s), _g_object_unref0 ((*_tmp1_)), _tmp2_);
				_g_free0 (s);
			}
		}
	}
	result = (_tmp3_ = rv, *result_length1 = rv_length1, _tmp3_);
	return result;
	rv = (_vala_array_free (rv, rv_length1, (GDestroyNotify) g_object_unref), NULL);
}


GSettings* deja_dup_get_settings (const char* subdir) {
	GSettings* result = NULL;
	char* schema;
	gboolean _tmp0_ = FALSE;
	schema = g_strdup ("org.gnome.DejaDup");
	if (subdir != NULL) {
		_tmp0_ = _vala_strcmp0 (subdir, "") != 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		char* _tmp1_;
		char* _tmp2_;
		schema = (_tmp2_ = g_strconcat (schema, _tmp1_ = g_strconcat (".", subdir, NULL), NULL), _g_free0 (schema), _tmp2_);
		_g_free0 (_tmp1_);
	}
	result = g_settings_new (schema);
	_g_free0 (schema);
	return result;
}


void deja_dup_convert_ssh_to_file (void) {
	GSettings* settings;
	char* backend;
	settings = deja_dup_get_settings (NULL);
	backend = g_strdup (g_settings_get_string (settings, DEJA_DUP_BACKEND_KEY));
	if (_vala_strcmp0 (backend, "ssh") == 0) {
		GSettings* ssh_settings;
		char* server;
		gboolean _tmp0_ = FALSE;
		g_settings_set_string (settings, DEJA_DUP_BACKEND_KEY, "file");
		ssh_settings = deja_dup_get_settings ("SSH");
		server = g_strdup (g_settings_get_string (ssh_settings, DEJA_DUP_SSH_SERVER_KEY));
		if (server != NULL) {
			_tmp0_ = _vala_strcmp0 (server, "") != 0;
		} else {
			_tmp0_ = FALSE;
		}
		if (_tmp0_) {
			char* username;
			gint port;
			char* directory;
			char* gio_uri;
			gboolean _tmp1_ = FALSE;
			char* _tmp4_;
			gboolean _tmp5_ = FALSE;
			gboolean _tmp9_ = FALSE;
			GSettings* file_settings;
			username = g_strdup (g_settings_get_string (ssh_settings, DEJA_DUP_SSH_USERNAME_KEY));
			port = g_settings_get_int (ssh_settings, DEJA_DUP_SSH_PORT_KEY);
			directory = g_strdup (g_settings_get_string (ssh_settings, DEJA_DUP_SSH_DIRECTORY_KEY));
			gio_uri = g_strdup ("ssh://");
			if (username != NULL) {
				_tmp1_ = _vala_strcmp0 (username, "") != 0;
			} else {
				_tmp1_ = FALSE;
			}
			if (_tmp1_) {
				char* _tmp2_;
				char* _tmp3_;
				gio_uri = (_tmp3_ = g_strconcat (gio_uri, _tmp2_ = g_strconcat (username, "@", NULL), NULL), _g_free0 (gio_uri), _tmp3_);
				_g_free0 (_tmp2_);
			}
			gio_uri = (_tmp4_ = g_strconcat (gio_uri, server, NULL), _g_free0 (gio_uri), _tmp4_);
			if (port > 0) {
				_tmp5_ = port != 22;
			} else {
				_tmp5_ = FALSE;
			}
			if (_tmp5_) {
				char* _tmp6_;
				char* _tmp7_;
				char* _tmp8_;
				gio_uri = (_tmp8_ = g_strconcat (gio_uri, _tmp7_ = g_strconcat (":", _tmp6_ = g_strdup_printf ("%i", port), NULL), NULL), _g_free0 (gio_uri), _tmp8_);
				_g_free0 (_tmp7_);
				_g_free0 (_tmp6_);
			}
			if (directory == NULL) {
				_tmp9_ = TRUE;
			} else {
				_tmp9_ = _vala_strcmp0 (directory, "") == 0;
			}
			if (_tmp9_) {
				char* _tmp10_;
				gio_uri = (_tmp10_ = g_strconcat (gio_uri, "/", NULL), _g_free0 (gio_uri), _tmp10_);
			} else {
				if (g_utf8_get_char (g_utf8_offset_to_pointer (directory, 0)) != '/') {
					char* _tmp11_;
					char* _tmp12_;
					gio_uri = (_tmp12_ = g_strconcat (gio_uri, _tmp11_ = g_strconcat ("/", directory, NULL), NULL), _g_free0 (gio_uri), _tmp12_);
					_g_free0 (_tmp11_);
				} else {
					char* _tmp13_;
					gio_uri = (_tmp13_ = g_strconcat (gio_uri, directory, NULL), _g_free0 (gio_uri), _tmp13_);
				}
			}
			file_settings = deja_dup_get_settings (DEJA_DUP_FILE_ROOT);
			g_settings_set_string (file_settings, DEJA_DUP_FILE_PATH_KEY, gio_uri);
			_g_object_unref0 (file_settings);
			_g_free0 (gio_uri);
			_g_free0 (directory);
			_g_free0 (username);
		}
		_g_free0 (server);
		_g_object_unref0 (ssh_settings);
	}
	_g_free0 (backend);
	_g_object_unref0 (settings);
}


void deja_dup_initialize (void) {
	deja_dup_convert_ssh_to_file ();
}


char* deja_dup_get_file_desc (GFile* file) {
	char* result = NULL;
	char* _tmp0_;
	char* _tmp1_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (file != NULL, NULL);
	{
		GFileInfo* info;
		info = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME "," G_FILE_ATTRIBUTE_STANDARD_DESCRIPTION, G_FILE_QUERY_INFO_NONE, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch8_g_error;
		}
		if (g_file_info_has_attribute (info, G_FILE_ATTRIBUTE_STANDARD_DESCRIPTION)) {
			result = g_strdup (g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_STANDARD_DESCRIPTION));
			_g_object_unref0 (info);
			return result;
		} else {
			if (g_file_info_has_attribute (info, G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME)) {
				result = g_strdup (g_file_info_get_attribute_string (info, G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME));
				_g_object_unref0 (info);
				return result;
			}
		}
		_g_object_unref0 (info);
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (e);
		}
	}
	__finally8:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = (_tmp1_ = g_path_get_basename (_tmp0_ = g_file_get_parse_name (file)), _g_free0 (_tmp0_), _tmp1_);
	return result;
}


char* deja_dup_get_location_desc (void) {
	char* result = NULL;
	GError * _inner_error_ = NULL;
	{
		DejaDupBackend* _tmp0_;
		DejaDupBackend* _tmp1_;
		char* _tmp2_;
		char* desc;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = deja_dup_backend_get_default (&_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch9_g_error;
		}
		desc = (_tmp2_ = deja_dup_backend_get_location_pretty (_tmp1_ = _tmp0_, &_inner_error_), _g_object_unref0 (_tmp1_), _tmp2_);
		if (_inner_error_ != NULL) {
			goto __catch9_g_error;
		}
		if (desc != NULL) {
			_tmp3_ = _vala_strcmp0 (desc, "") != 0;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			result = desc;
			return result;
		}
		_g_free0 (desc);
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
			_g_error_free0 (e);
		}
	}
	__finally9:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = g_strdup (_ ("Unknown"));
	return result;
}


gint deja_dup_get_full_backup_threshold (void) {
	gint result = 0;
	gint threshold;
	gint max;
	gint min;
	gint scale;
	gint min_fulls;
	GSettings* settings;
	gint delete_age;
	gboolean periodic;
	threshold = 7 * 6;
	max = 24 * 7;
	min = 4 * 7;
	scale = 12;
	min_fulls = 2;
	settings = deja_dup_get_settings (NULL);
	delete_age = g_settings_get_int (settings, DEJA_DUP_DELETE_AFTER_KEY);
	if (delete_age > 0) {
		max = MIN (delete_age / min_fulls, max);
	}
	periodic = g_settings_get_boolean (settings, DEJA_DUP_PERIODIC_KEY);
	if (periodic) {
		gint period;
		period = g_settings_get_int (settings, DEJA_DUP_PERIODIC_PERIOD_KEY);
		threshold = period * scale;
		CLAMP (threshold, min, max);
	} else {
		threshold = max;
	}
	result = threshold;
	_g_object_unref0 (settings);
	return result;
}


void deja_dup_get_full_backup_threshold_date (GDate* result) {
	GTimeVal now = {0};
	GDate date = {0};
	gint days;
	g_get_current_time (&now);
	g_get_current_time (&now);
	memset (&date, 0, sizeof (GDate));
	g_date_set_time_val (&date, &now);
	days = deja_dup_get_full_backup_threshold ();
	g_date_subtract_days (&date, (guint) days);
	*result = date;
	return;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




